// Entering other content modes
CATEGORY_OPEN	:	'[[' CATEGORY_TYPE	->		pushMode(CATEGORY);
FILE_OPEN		:	'[[' FILE_TYPE		->		pushMode(MODE_FILE);

INT_LINK_OPEN	:	'[['			->		pushMode(INT_LINK);
EXT_LINK_OPEN	:	'['				->		pushMode(EXT_LINK);

// Comments and footnotes are irrelevant for content processing
COMMENT 	: '<!--' .*? '-->'				-> skip;
SKIP_1 		: '<ref' .*? '/' [ ]* 'ref>'	-> skip;
SKIP_2 		: '<references' [ ]* '/>' 		-> skip;

// Stylistic annotations are irrelevant
STYLE_BOTH		:	'\'\'\'\'' -> skip;
STYLE_BOLD		:	'\'\'\'' -> skip;
STYLE_ITALICS	:	'\'\'' -> skip;

WS		:	[\t\r]+ -> skip ;

// Headings
H6_OPEN	:	'\n======';
H5_OPEN	:	'\n=====';
H4_OPEN	:	'\n====';
H3_OPEN	:	'\n===';
H2_OPEN	:	'\n==';
H1_OPEN	:	'\n=';

H6_CLOSE	:	'======';
H5_CLOSE	:	'=====';
H4_CLOSE	:	'====';
H3_CLOSE	:	'===';
H2_CLOSE	:	'==';
EQ		:	'=';


//NEWLINE	:	'\n'	-> skip;
EXCL	:	'\'' 
		| 	'['
		| 	'<'
		|	'\n';

// The remainder: actual textual content
TEXT		:	~[=\n\['<]+;


//--------------------------------------------------------------------------------
//---- Special Links (File Links, Categories)
//---- http://en.wikipedia.org/wiki/Wikipedia:FAQ/Categories
//--------------------------------------------------------------------------------
mode CATEGORY;
//--------------------------------------------------------------------------------
CATEGORY_CLOSE		:	']]'	->	popMode;
CATEGORY_INT_LINK_OPEN	:	'[['	->	pushMode(INT_LINK);
CATEGORY_EXT_LINK_OPEN	:	'['		->	pushMode(EXT_LINK);

CATEGORY_CONTENT	:	~[\]\[]+;

CATEGORY_TYPE		:	'Category:'
					|	'Kategorie:';
							
//--------------------------------------------------------------------------------
//---- Internal Links
//--------------------------------------------------------------------------------
mode INT_LINK;
//--------------------------------------------------------------------------------
INT_LINK_CLOSE			:	']]'	->	popMode;
INT_LINK_OPEN_REC		:	'[['	->	pushMode(INT_LINK);
INT_EXT_LINK_OPEN		:	'['		->	pushMode(EXT_LINK);


INT_LINK_CONTENT	:	~[\]\[\|]+;
INT_LINK_SEP		:	'|';

//--------------------------------------------------------------------------------
//---- External Links
//--------------------------------------------------------------------------------
mode EXT_LINK;
//--------------------------------------------------------------------------------
EXT_LINK_CLOSE			:	']'		->	popMode;
EXT_LINK_OPEN_REC		:	'['		->	pushMode(EXT_LINK);
EXT_INT_LINK_OPEN		:	'[['	->	pushMode(INT_LINK);


EXT_LINK_CONTENT	:	~[\]\[\| ]+;
EXT_LINK_SEP		:	' ';



//--------------------------------------------------------------------------------
//---- File Links
//---- Links to multimedia objects are considered irrelevant for the textual 
//---- content analysis and should not be mixed with surrounding text.
//--------------------------------------------------------------------------------
mode MODE_FILE;
//--------------------------------------------------------------------------------
FILE_CLOSE		:	']]'	->	popMode;
SKIP_OPEN		:	'['		->	pushMode(MODE_SKIP);

FILE_CONTENT	:	~[\]\[]+ -> skip;

FILE_TYPE		:	'File:'
				|	'Datei:';			

mode MODE_SKIP;
//--------------------------------------------------------------------------------
SKIP_CLOSE		:	']'		->	popMode;
SKIP_OPEN_REC	:	'['		->	pushMode(MODE_SKIP);

SKIP_CONTENT	:	~[\]\[]+ -> skip;
