page		:	container+;

// There should be only one container, multiple containers are formed if the
//	parser needs to recover from an error. 
container	:	(block | preface) block*;

preface		:	content;
block		:	h1block | h2block | h3block | h4block | h5block | h6block;

h1block	:	h1	(h2block | h3block | h4block | h5block | h6block | content)*;
h2block	:	h2	(h3block | h4block | h5block | h6block | content)*;
h3block	:	h3	(h4block | h5block | h6block | content)*;
h4block	:	h4	(h5block | h6block | content)*;
h5block	:	h5	(h6block | content)*;
h6block	:	h6	(content)*;

h1	:	H1_OPEN title EQ;
h2	:	H2_OPEN title H2_CLOSE;
h3	:	H3_OPEN title H3_CLOSE;
h4	:	H4_OPEN title H4_CLOSE;
h5	:	H5_OPEN title H5_CLOSE;
h6	:	H6_OPEN title H6_CLOSE;


content		:	(tokenset | categoryContainer)+;
title		:	tokenset+;

tokenset	:	text 
			| 	link;

// Category
categoryContainer	:	CATEGORY_OPEN category CATEGORY_CLOSE;
category			:	(CATEGORY_CONTENT | link)+;

// Links
link 	:	intLink	
		|	extLink
		|	fileLink;

// File links are ignored for textual processing
fileLink	:	FILE_OPEN skip* FILE_CLOSE;
skip		:	(SKIP_OPEN | SKIP_OPEN_REC) skip* SKIP_CLOSE;


// text contains the lexer identified TEXT and actual link display texts
text	:	TEXT | EXCL | EQ;

intLink		:	intLinkOpen intLinkCont INT_LINK_CLOSE;
intLinkOpen	:	INT_LINK_OPEN
			|	INT_LINK_OPEN_REC
			|	EXT_INT_LINK_OPEN
			|	CATEGORY_INT_LINK_OPEN;				
intLinkCont	:	intLinkComp? linkValue;

intLinkComp	:	intLinkRes INT_LINK_SEP (linkContent INT_LINK_SEP)*;

intLinkRes	:	linkContent;


extLink		:	extLinkOpen extLinkCont EXT_LINK_CLOSE;				
extLinkOpen	:	EXT_LINK_OPEN 
			|	EXT_LINK_OPEN_REC
			|	INT_EXT_LINK_OPEN
			|	CATEGORY_EXT_LINK_OPEN;					
extLinkCont	:	linkValue (EXT_LINK_SEP linkContent)?;

// An additional hierarchical level for later addressing
linkValue 	:	linkContent;

linkContent	:	(link | linkText)+;

linkText	:	INT_LINK_CONTENT 
			|	EXT_LINK_CONTENT 
			|	EXT_LINK_SEP;	
